#include "Graphics.h"


namespace Graphics
{
    int win_width;
    int win_height;
    SDL_Surface* screen;

    void Init()
    {
        win_width = 800;
        win_height = 600;

        putenv("SDL_VIDEO_CENTERED = 1");

        //Sets up the screen and displays the window
        screen = SDL_SetVideoMode(win_width, win_height, 32, SDL_SWSURFACE | SDL_DOUBLEBUF);

        SDL_WM_SetCaption("Physics Example", NULL);
    }

    void Resize(int width, int height)
    {
        win_width = width;
        win_height = height;

        screen = SDL_SetVideoMode(win_width, win_height, 32, SDL_SWSURFACE | SDL_DOUBLEBUF);
    }

    SDL_Surface* Load(std::string filename)
    {
        SDL_Surface* Image = NULL;
        SDL_Surface* TempImage = NULL;

        //Loads the image
        TempImage = IMG_Load(filename.c_str());
        //Optimizes the image
        Image = SDL_DisplayFormatAlpha(TempImage);
        //Frees the TempImage to free memory
        SDL_FreeSurface(TempImage);

        return Image;

    }

    void DrawImage(SDL_Surface* image, int x, int y)
    {
        SDL_Rect dest;

        dest.x = x;
        dest.y = y;

        SDL_BlitSurface(image, NULL, screen, &dest);
    }

    //Extra parameters for source rect
    //The sx and sy creates a vertex in the image
    //The swidth and sheight are then used to create a rectangle in the image
    //This rectangle is what is drawn, instead of the whole image
    void DrawImage(SDL_Surface* image, int dx, int dy, int sx, int sy, int sw, int sh)
    {
        SDL_Rect dest, src;

        dest.x = dx;
        dest.y = dy;
        src.x = sx;
        src.y = sy;
        src.w = sw;
        src.h = sh;

        SDL_BlitSurface(image, &src, screen, &dest);
    }

    void DrawImage(SDL_Surface* image, int dx, int dy, SDL_Rect* src)
    {
        SDL_Rect dest;

        dest.x = dx;
        dest.y = dy;

        SDL_BlitSurface(image, src, screen, &dest);
    }

    void Quit()
    {
        SDL_FreeSurface(screen);
    }
}
