#ifndef GRAPHICS_H_INCLUDED
#define GRAPHICS_H_INCLUDED

#include <SDL.h>
#include <SDL_image.h>
#include <string>

/////////////////////////////////////////////////////////////////////////
//Namespace Graphics
/////////////////////////////////////////////////////////////////////////
//Used for blitting, screen aspect changing, and image loading
/////////////////////////////////////////////////////////////////////////

namespace Graphics
{
    //////Functions//////

    //Called at beginning of program run, initializes Graphics
    void Init();

    //Changes the width and height of the screen
    void Resize(int, int);

    //Returns an image when filename is passed (IMG_Load)
    SDL_Surface* Load(std::string);

    //Draws the given surface at the given x and y
    void DrawImage(SDL_Surface*, int, int);

    //Draws the given source rect of the given surface at the given x and y
    void DrawImage(SDL_Surface*, int, int, int, int, int, int);

    void DrawImage(SDL_Surface*, int, int, SDL_Rect*);

    //Frees memory, called at program exit
    void Quit();


    //////Member Variables//////

    //Represents the window, images are drawn to it
    extern SDL_Surface* screen;

    //Used to store the width and height of the screen
    extern int win_width;
    extern int win_height;
}

#endif // GRAPHICS_H_INCLUDED
