// ball.cpp

#include "ball.h"

#include <iostream>
using namespace std;

vector <Ball*> Ball::vBall;

Ball::Ball(int tx, int ty) // constructor
{
    BallIMG = Graphics::Load("images/ball.png");

    x = tx;
    y = ty;
    mass = 5;

    xspeed = 4;
    yspeed = -5;
}


Ball::~Ball()// deconstructor
{
    SDL_FreeSurface(BallIMG);
    BallIMG = NULL;
}

void Ball::Draw()
{
    Graphics::DrawImage(BallIMG, x, y);
}


void Ball::Update()
{
    yspeed += G;//acceleration

    y += yspeed;

    xspeed = xspeed * (.9948); // some air resistance? fake value
    x += xspeed;
}

void Ball::CreateOnClick(int mx, int my)
{
    Ball *temp;

        temp = new Ball(mx, my);

        vBall.push_back(temp);

        temp = 0;

    delete temp;
}

void Ball::CheckWallCollision()
{       //
    float e = 0.65; //friction

        if (y + 30 > 600)
        {
            y = 570;
        }

        if (y + 30 >= 600) // collision
        {
            //force = (force * e);
            yspeed = (yspeed * e) * -1;
        }

        if (x + 30 >= 800) // collision
        {
            if (x + 30 > 800)
                {
                    x = 770;
                }
            xspeed = xspeed * -1;  // reverse speed
        }

        if (x <= 0) // collision
        {
            if (x < 0)
                {
                    x = 0;
                }
            xspeed = xspeed * -1;  // reverse speed
        }
}

int Ball::Getx()
{
    return x;
}

int Ball::Gety()
{
    return y;
}

void Ball::BallCollision(Ball* b2)
{
       float R = 1;
       float m21, dvx2, a, x21, y21, vx21, vy21, fy21, sign, vx_cm, vy_cm; //cm center mass?


       m21 = b2->mass / mass;
       y21 = b2->y - y;
       x21 = b2->x - x;
       vx21 = b2->xspeed - xspeed;
       vy21 = b2->yspeed - yspeed;

       vx_cm = (mass * xspeed + b2->mass * b2->xspeed) / (mass + b2->mass);
       vy_cm = (mass * yspeed + b2->mass * b2->yspeed) / (mass + b2->mass);


//     *** return old velocities if balls are not approaching ***
       if ((vx21 * x21 + vy21 * y21) >= 0) return;


//     *** I have inserted the following statements to avoid a zero divide;
//         (for single precision calculations,
//          1.0E-12 should be replaced by a larger value). **************

       fy21 = 1.0E-12 * fabs(y21);
       if (fabs(x21) < fy21)
       {
            if (x21 < 0)
            {
                sign =- 1;
            }
            else
            {
                sign = 1;
            }
            x21 = fy21 * sign;
       }

//     ***  update velocities ***
       a = y21 / x21;
       dvx2 = -2 * (vx21 + a * vy21) / ((1 + a * a) * (1 + m21));
       b2->xspeed = b2->xspeed + dvx2;
       b2->yspeed = b2->yspeed + a * dvx2;
       xspeed = xspeed - m21 * dvx2;
       yspeed = yspeed - a * m21 * dvx2;

//     ***  velocity correction for inelastic collisions ***
       xspeed = (xspeed - vx_cm) * R + vx_cm;
       yspeed = (yspeed - vy_cm) * R + vy_cm;
       b2->xspeed = (b2->xspeed - vx_cm) * R + vx_cm;
       b2->yspeed = (b2->yspeed - vy_cm) * R + vy_cm;

       return;
}

bool Ball::CheckBallCollision(Ball* b2)
{
    int a, b, r;
    a = x - b2->x;
    b = y - b2->y;
    r = (BallIMG->h/2 + b2->BallIMG->h/2);          //both radii added for the collision distance
    float d = hypotf(a, b);                         //compute the actual distance
                                                            //aka (y2 - y1) / (x2 - x1)
    if(d <= r) return true;

    return false;
}

void Ball::Delete()
{
    for (int i; i < vBall.size(); ++i)
    {
        vBall[i]->Ball::~Ball();
        delete vBall[i];
    }
    vBall.clear();
}
