#include "Graphics.h"
#include "ball.h"
#include "mouse.h"
#include "FPS.h"
#include "text.h"

SDL_Surface* Background;

int main(int argc, char* args[])
{
    if(SDL_Init(SDL_INIT_EVERYTHING) < 0)
    {
       return false;
    }
    atexit(SDL_Quit);

    srand(time(0)); //random
    SDL_ShowCursor(0);//0 - hides mouse, 1 - shows mouse

    Graphics::Init();
         FPS::Init(60);
        Text::Init();

    Mouse *cursor = new Mouse;

    bool Running = true;

    SDL_Event Event;

    Background = Graphics::Load("images/background.png");

    while(Running)
    {
        while(SDL_PollEvent(&Event))
            {
                 switch(Event.type)
                      {
                           case SDL_KEYDOWN:
                              switch(Event.key.keysym.sym)
                              {
                                  case SDLK_ESCAPE: Running = false;
                                  break;

                                  default: break;
                              }
                           break;

                           case SDL_KEYUP:
                           break;

                           case SDL_QUIT: Running = false;
                           break;

                           case SDL_MOUSEMOTION:
                              {
                                  cursor->UpdateCoor(Event.motion.x, Event.motion.y);
                              }
                           break;

                           case SDL_MOUSEBUTTONDOWN:
                                switch(Event.button.button)
                                {
                                   case SDL_BUTTON_LEFT:
                                        Ball::CreateOnClick(cursor->GetX(), cursor->GetY());
                                   break;

                                   case SDL_BUTTON_RIGHT:
                                        Ball::Delete();
                                   break;

                                   default: break;
                                }
                            break;

                           default: break;
                      } // end of event.type
             }// end of pollevent

        Graphics::DrawImage(Background, 0, 0);

        for (int i = 0; i < Ball::vBall.size(); i++)
        {
            Ball::vBall[i]->Update();
            Ball::vBall[i]->CheckWallCollision();
            Ball::vBall[i]->Draw();
            for(int j = 0; j < Ball::vBall.size(); j++)
            {
                if(i != j)
                {
                    if(Ball::vBall[i]->CheckBallCollision(Ball::vBall[j]))
                        Ball::vBall[i]->BallCollision(Ball::vBall[j]);
                }
            }
        }

        cursor->Draw();
        Text::Draw(Ball::vBall.size(), 24, 0, 0, 255, 0, 0, 0);

    SDL_Flip(Graphics::screen);
    FPS::FPS_Cap();
    }  //end of while(running)

    delete cursor; cursor = 0;
    Ball::Delete();
    Graphics::Quit();

    return 0;
}  //end int main
